# Metal FS Hands-On 1: Simulation

Clone the Metal FS GitHub repository:

```bash
git clone https://github.com/osmhpi/metal_fs
cd metal_fs
git checkout tutorial
```

Compile the software components:
```bash
mkdir build
cd build
# This configures the build system
cmake ..
make
```

Build a hardware simulation model (for simulation purposes without DRAM and NVMe):
```bash
cd snap
make snap_config
# In the config menu:
# - Select HDL Action
# - Unselect NVMe and SDRAM if selected
# - Save

# Open snap_env.sh and set ACTION_ROOT
# ACTION_ROOT=~/metal_fs/src/metal_fpga

make model
```

Try out Metal FS in the simulator:
```bash
mkdir /mnt/$USER/metal_fs
make sim

# In the simulation shell:
$SNAP_ROOT/software/tools/snap_maint
$ACTION_ROOT/../../build/metal_fs -s -f /mnt/$USER/metal_fs

# In another shell:
cd /mnt/$USER/metal_fs
echo Hello World | ./operators/change_case
```

